implementation class
Terminal: Symbol

end;

implementation instance
Terminal
{
  <doc> The token value.  </doc>
  public int token_value;

  <doc> Number of this terminal in the closed Vt enumeration ({v-terminals}
      in {parser}).  </doc>
  public mutable int rank;
}

<doc> Designated initializer.  </doc>
id
  init int v
{
  (token_value, rank) = (v, -1);
  = [super init];
}

void
  checkLL1
{
}

boolean
  outputBefore Array attributes
{
  return attributes == nil;
}

OutputStream
	 compile OutputStream s
  withAttributes Array attributes
{
  if (attributes != nil)
    s = [s print (({Any a = attributes[0];}), " = [lex semantics];")];

  = [[isa name [s print (indent, "[self term ")] token token_value]
      print "];"];
}

IntegerRangeSet
  computeLA IntegerRangeSet follow
{
  if (!la)
    {
      la = first = [IntegerRangeSet new];
      [la add token_value];
    }

  = la;
}

OutputStream (s)
  describe-flat-rule OutputStream s
{
  [parser describeGenerated s token token_value];
}

<doc> Return {TRUE} if this is a {%predef} token.  The default
    implementation returns {FALSE}.  </doc>
boolean
  predef
{
}

boolean
  isTerminal
{
  = YES;
}

OutputStream
  write OutputStream s
{
  = [super (Symbol) write s];
}

OutputStream (s)
  writeFields OutputStream s
{
  [[parser describeGenerated [[super (Symbol) writeFields s] print " token="]
	   token token_value] print (" rank=", rank)];
}

end;
